install.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. s390x) echo 's390x' ;;
  30. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  31. esac
  32. }
  33. echo "arch: $(arch)"
  34. os_version=""
  35. os_version=$(grep "^VERSION_ID" /etc/os-release | cut -d '=' -f2 | tr -d '"' | tr -d '.')
  36. if [[ "${release}" == "arch" ]]; then
  37. echo "Your OS is Arch Linux"
  38. elif [[ "${release}" == "parch" ]]; then
  39. echo "Your OS is Parch Linux"
  40. elif [[ "${release}" == "manjaro" ]]; then
  41. echo "Your OS is Manjaro"
  42. elif [[ "${release}" == "armbian" ]]; then
  43. echo "Your OS is Armbian"
  44. elif [[ "${release}" == "opensuse-tumbleweed" ]]; then
  45. echo "Your OS is OpenSUSE Tumbleweed"
  46. elif [[ "${release}" == "openEuler" ]]; then
  47. if [[ ${os_version} -lt 2203 ]]; then
  48. echo -e "${red} Please use OpenEuler 22.03 or higher ${plain}\n" && exit 1
  49. fi
  50. elif [[ "${release}" == "centos" ]]; then
  51. if [[ ${os_version} -lt 8 ]]; then
  52. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  53. fi
  54. elif [[ "${release}" == "ubuntu" ]]; then
  55. if [[ ${os_version} -lt 2004 ]]; then
  56. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  57. fi
  58. elif [[ "${release}" == "fedora" ]]; then
  59. if [[ ${os_version} -lt 36 ]]; then
  60. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  61. fi
  62. elif [[ "${release}" == "amzn" ]]; then
  63. if [[ ${os_version} != "2023" ]]; then
  64. echo -e "${red} Please use Amazon Linux 2023!${plain}\n" && exit 1
  65. fi
  66. elif [[ "${release}" == "debian" ]]; then
  67. if [[ ${os_version} -lt 11 ]]; then
  68. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  69. fi
  70. elif [[ "${release}" == "almalinux" ]]; then
  71. if [[ ${os_version} -lt 80 ]]; then
  72. echo -e "${red} Please use AlmaLinux 8.0 or higher ${plain}\n" && exit 1
  73. fi
  74. elif [[ "${release}" == "rocky" ]]; then
  75. if [[ ${os_version} -lt 8 ]]; then
  76. echo -e "${red} Please use Rocky Linux 8 or higher ${plain}\n" && exit 1
  77. fi
  78. elif [[ "${release}" == "ol" ]]; then
  79. if [[ ${os_version} -lt 8 ]]; then
  80. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  81. fi
  82. else
  83. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  84. echo "Please ensure you are using one of the following supported operating systems:"
  85. echo "- Ubuntu 20.04+"
  86. echo "- Debian 11+"
  87. echo "- CentOS 8+"
  88. echo "- OpenEuler 22.03+"
  89. echo "- Fedora 36+"
  90. echo "- Arch Linux"
  91. echo "- Parch Linux"
  92. echo "- Manjaro"
  93. echo "- Armbian"
  94. echo "- AlmaLinux 8.0+"
  95. echo "- Rocky Linux 8+"
  96. echo "- Oracle Linux 8+"
  97. echo "- OpenSUSE Tumbleweed"
  98. echo "- Amazon Linux 2023"
  99. exit 1
  100. fi
  101. install_base() {
  102. case "${release}" in
  103. ubuntu | debian | armbian)
  104. apt-get update && apt-get install -y -q wget curl tar tzdata
  105. ;;
  106. centos | almalinux | rocky | ol)
  107. yum -y update && yum install -y -q wget curl tar tzdata
  108. ;;
  109. fedora | amzn)
  110. dnf -y update && dnf install -y -q wget curl tar tzdata
  111. ;;
  112. arch | manjaro | parch)
  113. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  114. ;;
  115. opensuse-tumbleweed)
  116. zypper refresh && zypper -q install -y wget curl tar timezone
  117. ;;
  118. *)
  119. apt-get update && apt install -y -q wget curl tar tzdata
  120. ;;
  121. esac
  122. }
  123. gen_random_string() {
  124. local length="$1"
  125. local random_string=$(LC_ALL=C tr -dc 'a-zA-Z0-9' </dev/urandom | fold -w "$length" | head -n 1)
  126. echo "$random_string"
  127. }
  128. config_after_install() {
  129. local existing_username=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'username: .+' | awk '{print $2}')
  130. local existing_password=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'password: .+' | awk '{print $2}')
  131. local existing_webBasePath=$(/usr/local/x-ui/x-ui setting -show true | grep -Eo 'webBasePath: .+' | awk '{print $2}')
  132. # Check if username and password exist
  133. if [[ -n "$existing_username" && -n "$existing_password" ]]; then
  134. # If webBasePath is missing, generate a new one
  135. if [[ ${#existing_webBasePath} -lt 4 ]]; then
  136. local config_webBasePath=$(gen_random_string 15)
  137. echo -e "${yellow}WebBasePath is missing or too short. Generating a new one...${plain}"
  138. /usr/local/x-ui/x-ui setting -webBasePath "${config_webBasePath}"
  139. echo -e "${green}New WebBasePath: ${config_webBasePath}${plain}"
  140. else
  141. echo -e "${green}Username, Password, and WebBasePath are already set. Exiting...${plain}"
  142. return 0
  143. fi
  144. fi
  145. read -p "Would you like to customize the Panel Port settings? (If not, random settings will be applied) [y/n]: " config_confirm
  146. local config_webBasePath=$(gen_random_string 15)
  147. local config_username=$(gen_random_string 10)
  148. local config_password=$(gen_random_string 10)
  149. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  150. read -p "Please set up the panel port: " config_port
  151. echo -e "${yellow}Your Panel Port is: ${config_port}${plain}"
  152. echo -e "${yellow}Your Username will be generated randomly: ${config_username}${plain}"
  153. echo -e "${yellow}Your Password will be generated randomly: ${config_password}${plain}"
  154. echo -e "${yellow}Your Web Base Path will be generated randomly: ${config_webBasePath}${plain}"
  155. echo -e "${yellow}Initializing, please wait...${plain}"
  156. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}" -port "${config_port}" -webBasePath "${config_webBasePath}"
  157. echo -e "${green}Settings applied successfully!${plain}"
  158. echo -e "###############################################"
  159. echo -e "${green}Username: ${config_username}${plain}"
  160. echo -e "${green}Password: ${config_password}${plain}"
  161. echo -e "${green}Port: ${config_port}${plain}"
  162. echo -e "${green}WebBasePath: ${config_webBasePath}${plain}"
  163. echo -e "###############################################"
  164. else
  165. echo -e "${red}Cancel...${plain}"
  166. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  167. local portTemp=$(shuf -i 1024-62000 -n 1)
  168. /usr/local/x-ui/x-ui setting -username "${config_username}" -password "${config_password}" -port "${portTemp}" -webBasePath "${config_webBasePath}"
  169. echo -e "This is a fresh installation, generating random login info for security concerns:"
  170. echo -e "###############################################"
  171. echo -e "${green}Username: ${config_username}${plain}"
  172. echo -e "${green}Password: ${config_password}${plain}"
  173. echo -e "${green}Port: ${portTemp}${plain}"
  174. echo -e "${green}WebBasePath: ${config_webBasePath}${plain}"
  175. echo -e "###############################################"
  176. echo -e "${yellow}If you forgot your login info, you can type 'x-ui settings' to check after installation${plain}"
  177. else
  178. echo -e "${yellow}This is your upgrade, keeping old settings. If you forgot your login info, you can type 'x-ui settings' to check${plain}"
  179. fi
  180. fi
  181. /usr/local/x-ui/x-ui migrate
  182. }
  183. install_x-ui() {
  184. cd /usr/local/
  185. if [ $# == 0 ]; then
  186. tag_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  187. if [[ ! -n "$tag_version" ]]; then
  188. echo -e "${red}Failed to fetch x-ui version, it may be due to GitHub API restrictions, please try it later${plain}"
  189. exit 1
  190. fi
  191. echo -e "Got x-ui latest version: ${tag_version}, beginning the installation..."
  192. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz
  193. if [[ $? -ne 0 ]]; then
  194. echo -e "${red}Downloading x-ui failed, please be sure that your server can access GitHub ${plain}"
  195. exit 1
  196. fi
  197. else
  198. tag_version=$1
  199. tag_version_numeric=${tag_version#v}
  200. min_version="2.3.5"
  201. if [[ "$(printf '%s\n' "$min_version" "$tag_version_numeric" | sort -V | head -n1)" != "$min_version" ]]; then
  202. echo -e "${red}Please use a newer version (at least v2.3.5). Exiting installation.${plain}"
  203. exit 1
  204. fi
  205. url="https://github.com/MHSanaei/3x-ui/releases/download/${tag_version}/x-ui-linux-$(arch).tar.gz"
  206. echo -e "Beginning to install x-ui $1"
  207. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  208. if [[ $? -ne 0 ]]; then
  209. echo -e "${red}Download x-ui $1 failed, please check if the version exists ${plain}"
  210. exit 1
  211. fi
  212. fi
  213. if [[ -e /usr/local/x-ui/ ]]; then
  214. systemctl stop x-ui
  215. rm /usr/local/x-ui/ -rf
  216. fi
  217. tar zxvf x-ui-linux-$(arch).tar.gz
  218. rm x-ui-linux-$(arch).tar.gz -f
  219. cd x-ui
  220. chmod +x x-ui
  221. # Check the system's architecture and rename the file accordingly
  222. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  223. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  224. chmod +x bin/xray-linux-arm
  225. fi
  226. chmod +x x-ui bin/xray-linux-$(arch)
  227. cp -f x-ui.service /etc/systemd/system/
  228. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  229. chmod +x /usr/local/x-ui/x-ui.sh
  230. chmod +x /usr/bin/x-ui
  231. config_after_install
  232. systemctl daemon-reload
  233. systemctl enable x-ui
  234. systemctl start x-ui
  235. echo -e "${green}x-ui ${tag_version}${plain} installation finished, it is running now..."
  236. echo -e ""
  237. echo -e "x-ui control menu usages: "
  238. echo -e "----------------------------------------------"
  239. echo -e "SUBCOMMANDS:"
  240. echo -e "x-ui - Admin Management Script"
  241. echo -e "x-ui start - Start"
  242. echo -e "x-ui stop - Stop"
  243. echo -e "x-ui restart - Restart"
  244. echo -e "x-ui status - Current Status"
  245. echo -e "x-ui settings - Current Settings"
  246. echo -e "x-ui enable - Enable Autostart on OS Startup"
  247. echo -e "x-ui disable - Disable Autostart on OS Startup"
  248. echo -e "x-ui log - Check logs"
  249. echo -e "x-ui banlog - Check Fail2ban ban logs"
  250. echo -e "x-ui update - Update"
  251. echo -e "x-ui custom - custom version"
  252. echo -e "x-ui install - Install"
  253. echo -e "x-ui uninstall - Uninstall"
  254. echo -e "----------------------------------------------"
  255. }
  256. echo -e "${green}Running...${plain}"
  257. install_base
  258. install_x-ui $1